unit BWStrUtils;

interface

function replace(var Str : string; SourceString,DestString:string):boolean;

function ExtractWord(str : string; n:integer):string;

function FstNonSpace(str : string):integer;

function NextWordBegin(str : string; CurrentPos : integer): integer;

function LastPos(SubStr : string; Strn:String): integer;
{ Returns the beginning of the last substring in a string }

Function LineIsEmpty( str : string ):boolean;
// Returns true, if line doesn't contain any characters except, probably, spaces and tabs

function CompleteLine(Str:String; FLen:integer; symb:char):string;
{ completes a string with some chars }

Function MakeString(FLen : Integer; Symb : char ):string;
// creates a new string, filled with specified chars

implementation

function replace;
var i:integer;
begin
  i:=pos(SourceString,Str);
  if i=0 then
  begin
    result:=false;
    exit;
  end;
  Delete(Str,i,Length(SourceString));
  Insert(DestString,Str,i);
  result:=true;
end;

function extractword(str : string; n : integer) : string;
var
    count : integer;
    i : integer;
    len : integer;
    done : boolean;
    retstr : string;

begin
  retstr := '';
  len := length(str);
  count := 0;
  i := 1;
  done := false;
  while (i <= len) and (not done) do
    begin
    while ((i <= len) and ((str[i] = #32) or (str[i] = #9) or (str[i] = ';'))) do
      inc(i);
    if i <= len then
      inc(count);
    if count = n then
      begin
      setstring(retstr,nil,0);
      if (i > 1) then
        if str[i-1] = ';' then
          retstr := ';';
      while ((i <= len) and ((str[i] <> #32) and (str[i] <> #9) and (str[i] <> ';'))) do
        begin
        setlength(retstr,length(retstr)+1);
        retstr[ord(length(retstr))] := str[i];
        inc(i);
        end;
      done := true;
      end
    else
      while ((i <= len) and ((str[i] <> #32) and (str[i] <> #9) and (str[i] <> ';'))) do
        inc(i);
    end;
  result := retstr;
end;

function FstNonSpace(str:string):integer;
var //P : PChar;
    i : integer;

begin
  i:=1;
  while (i<Length(Str)) and ((str[i]=#32) or (str[i]=#9)) do inc(i);
  if i=Length(Str) then result:=-1 else result:=i;
end;

function NextWordBegin(str:string; CurrentPos : integer): integer;
var i : integer;
begin
  i:=CurrentPos;
  while (i<Length(str)) and ((Str[i]=#32) or (Str[i]=#9)) do inc(i);
  if i=Length(str) then result:=-1 else result:=i;    
end;

Function LastPos(SubStr:string; Strn:String):integer;
var s : string;
    n : integer;

begin
 s:=Strn;
 n:=0;
 while Pos(Substr,s)>0 do
 begin
  n:=n+Pos(Substr,s);
  s:=Copy(Strn, n+1, Length(Strn));
 end;
 if n=0 then n:=-1;
 Result:=n;
end;

Function LineIsEmpty( str : string ):boolean;
begin
  result:=FstNonSpace( str )=-1;
end;

function CompleteLine(Str:String; FLen:integer; symb:char):string;
var S:String;
    i,j:integer;
begin
 s:=Str;
 if Length(s)>=FLen then
 begin
  result:=s;
  Exit;
 end;
 j:=Length(S);
 SetLength(S, FLen);
 for i:=j to FLen do
 begin
  S[i]:=symb;
 end;
 result:=s;
end;

Function MakeString(FLen : Integer; Symb : char ):string;
begin
  result:='';
  CompleteLine(result, FLen, Symb);
end;


end.

